#include<bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //vrlo sam lenj i samo zelim bodove
    unordered_set<int> kalkulacije;
    int t;
    cin>>t;
    vector<int> brojevi;
    while(t--){
        int temp;
        cin>>temp;
        brojevi.push_back(temp);
    }
    sort(brojevi.begin(), brojevi.end());
    int najdaljiBroj = 0;
    int nadjenihUnikatnihZaNajdalji = 0;
    for(int i = 0; i<brojevi.size(); i++){
        int rez = 0;
        for(int j = najdaljiBroj+1; j<=brojevi[i]; j++){
            int produkt = 1;
            int tempJ = j;
            while(tempJ){
                produkt*=tempJ%10;
                tempJ = tempJ/10;
            }
            if(!kalkulacije.count(produkt)){
                kalkulacije.insert(produkt);
                rez++;
            }

        }
        najdaljiBroj = brojevi[i];
        nadjenihUnikatnihZaNajdalji += rez;
        cout<<nadjenihUnikatnihZaNajdalji<<"\n";
    }
    return 0;
}